/*  Spruce
 *  Copyright (C) 1999 Susixware
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, 
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/*
 * Filters.c originaly written by Kristoffer Brnemyr <ztion@swipnet.se>
 *
*/

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "filters.h"

/* external variables */
extern gchar *spruceconf;                /* spruce config file name */
extern GtkWidget *frmFilters;
extern gint FiltersOpen;                /* is frmFilters opened?? */
extern GtkWidget *frmMain;
extern gint NumMailboxes;

GtkWidget *dlgNewFilter;
GList *filters_mailboxes = NULL;
extern GList *filters;

GtkWidget* create_frmFilters (void)
{
   GtkWidget *frmFilters;
   GtkWidget *box1;
   GtkWidget *box2;
   GtkWidget *box3;
   GtkWidget *box4;
   GtkWidget *action_frame;
   GSList *action_button_group;
   GtkWidget *action_move_button;
   GtkWidget *action_move_label;
   GtkWidget *action_move_combo;
   GtkWidget *action_forward_button;
   GtkWidget *action_forward_label;
   GtkWidget *action_forward_entry;
   GtkWidget *action_delete_label;
   GtkWidget *action_delete_button;
   GtkWidget *action_box1;
   GtkWidget *action_box2;
   GtkWidget *action_box3;
   GtkWidget *action_box4;
   GtkWidget *filters_frame;
   GtkWidget *filters_clist;
   gchar *filters_clist_titles[1] = { _("Filter") };
   GtkWidget *match_box1;
   GtkWidget *match_box2;
   GtkWidget *match_box3;
   GtkWidget *match_frame;
   GtkWidget *match_text_entry;
   GtkWidget *match_text_label;
   GtkWidget *match_in_combo;
   GtkWidget *match_in_label;
   GList *match_in_combo_opts = NULL;
   GtkWidget *buttons_box1;
   GtkWidget *cmdFiltersOk;
   GtkWidget *cmdFiltersSave;
   GtkWidget *cmdFiltersNew;
   GtkWidget *cmdFiltersDel;
  
   frmFilters = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(frmFilters), _("Edit Filters"));
   gtk_widget_set_usize(frmFilters, 500, 300);
   gtk_container_set_border_width(GTK_CONTAINER(frmFilters), 10);
   gtk_signal_connect_object (GTK_OBJECT (frmFilters), "destroy",
                             GTK_SIGNAL_FUNC (on_frmFilters_destroy),
                             GTK_OBJECT (frmFilters));

   box4 = gtk_vbox_new(FALSE, FALSE);
   gtk_container_add(GTK_CONTAINER(frmFilters), box4);
   gtk_widget_show(box4);

   box1 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(box4), box1, TRUE, TRUE, 0);
   gtk_widget_show(box1);

   box2 = gtk_vbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, FALSE, 0);
   gtk_widget_show(box2);
 
   box3 = gtk_vbox_new(FALSE, FALSE);
   gtk_box_pack_end(GTK_BOX(box1), box3, TRUE, TRUE, 5);
   gtk_widget_show(box3);

   action_frame = gtk_frame_new(_("Actions"));
   gtk_box_pack_start(GTK_BOX(box2), action_frame, TRUE, TRUE, 0);
   gtk_widget_show(action_frame);

   action_box1 = gtk_vbox_new(FALSE, FALSE);
   gtk_container_add(GTK_CONTAINER(action_frame), action_box1);
   gtk_widget_show(action_box1);

   action_box2 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(action_box1), action_box2, FALSE, FALSE, 0);
   gtk_widget_show(action_box2);

   action_move_button = gtk_radio_button_new(NULL);
   gtk_widget_set_name(action_move_button, "action_move_button");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "action_move_button", action_move_button);
   gtk_widget_show(action_move_button);
   gtk_box_pack_start(GTK_BOX(action_box2), action_move_button, FALSE, FALSE, 5);
 
   action_move_label = gtk_label_new(_("Move to mailbox"));
   gtk_widget_show(action_move_label);
   gtk_box_pack_start(GTK_BOX(action_box2), action_move_label, FALSE, FALSE, 5);

   action_move_combo = gtk_combo_new();
   gtk_widget_set_name(action_move_combo, "action_move_combo");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "action_move_combo", action_move_combo);
   gtk_signal_connect(GTK_OBJECT(GTK_COMBO(action_move_combo)->button), "pressed", GTK_SIGNAL_FUNC(on_cmdFiltersMoveComboButton_clicked), NULL);
   gtk_box_pack_start(GTK_BOX(action_box2), action_move_combo, TRUE, TRUE, 5);
   gtk_widget_show(action_move_combo);

   action_box3 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(action_box1), action_box3, FALSE, FALSE, 5);
   gtk_widget_show(action_box3);

   action_button_group = gtk_radio_button_group(GTK_RADIO_BUTTON(action_move_button));
   action_forward_button = gtk_radio_button_new(action_button_group);
   gtk_widget_set_name(action_forward_button, "action_forward_button");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "action_forward_button", action_forward_button);
   gtk_box_pack_start(GTK_BOX(action_box3), action_forward_button, FALSE, FALSE, 5);
   gtk_widget_show(action_forward_button);

   action_forward_label = gtk_label_new(_("Forward to"));
   gtk_box_pack_start(GTK_BOX(action_box3), action_forward_label, FALSE, FALSE, 5);
   gtk_widget_show(action_forward_label);

   action_forward_entry = gtk_entry_new();
   gtk_widget_set_name(action_forward_entry, "action_forward_entry");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "action_forward_entry", action_forward_entry);
   gtk_box_pack_start(GTK_BOX(action_box3), action_forward_entry, TRUE, TRUE, 5);
   gtk_widget_show(action_forward_entry);

   action_box4 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(action_box1), action_box4, FALSE, FALSE, 0);
   gtk_widget_show(action_box4);
 
   action_button_group = gtk_radio_button_group(GTK_RADIO_BUTTON(action_forward_button));
   action_delete_button = gtk_radio_button_new(action_button_group);
   gtk_widget_set_name(action_delete_button, "action_delete_button");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "action_delete_button", action_delete_button);
   gtk_box_pack_start(GTK_BOX(action_box4), action_delete_button, FALSE, FALSE, 5);
   gtk_widget_show(action_delete_button);

   action_delete_label = gtk_label_new(_("Delete message"));
   gtk_box_pack_start(GTK_BOX(action_box4), action_delete_label, FALSE, FALSE, 5);
   gtk_widget_show(action_delete_label);
  
   match_frame = gtk_frame_new(_("Match"));
   gtk_box_pack_start(GTK_BOX(box2), match_frame, FALSE, FALSE, 0);
   gtk_widget_show(match_frame);

   match_box1 = gtk_vbox_new(FALSE, FALSE);
   gtk_container_add(GTK_CONTAINER(match_frame), match_box1);
   gtk_widget_show(match_box1);

   match_box2 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_start(GTK_BOX(match_box1), match_box2, FALSE, FALSE, 0);
   gtk_widget_show(match_box2);
 
   match_text_label = gtk_label_new(_("Text"));
   gtk_widget_show(match_text_label);
   gtk_box_pack_start(GTK_BOX(match_box2), match_text_label, FALSE, FALSE, 5);
 
   match_text_entry = gtk_entry_new();
   gtk_widget_set_name(match_text_entry, "match_text_entry");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "match_text_entry", match_text_entry);
   gtk_widget_show(match_text_entry);
   gtk_box_pack_start(GTK_BOX(match_box2), match_text_entry, TRUE, TRUE, 5);
 
   match_box3 = gtk_hbox_new(FALSE, FALSE);
   gtk_box_pack_end(GTK_BOX(match_box1), match_box3, FALSE, FALSE, 5);
   gtk_widget_show(match_box3);
   
   match_in_label = gtk_label_new(_("In"));
   gtk_widget_show(match_in_label);
   gtk_box_pack_start(GTK_BOX(match_box3), match_in_label, FALSE, FALSE, 5);

   match_in_combo = gtk_combo_new();
   gtk_widget_set_name(match_in_combo, "match_in_combo");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "match_in_combo", match_in_combo);
   /* these should do by default */
   match_in_combo_opts = g_list_append(match_in_combo_opts, "To:");
   match_in_combo_opts = g_list_append(match_in_combo_opts, "From:");
   match_in_combo_opts = g_list_append(match_in_combo_opts, "Sender:");
   match_in_combo_opts = g_list_append(match_in_combo_opts, "Subject:");
   match_in_combo_opts = g_list_append(match_in_combo_opts, "Cc:");
	match_in_combo_opts = g_list_append(match_in_combo_opts, "Any recipient");
   gtk_combo_set_popdown_strings(GTK_COMBO(match_in_combo), match_in_combo_opts);
   gtk_widget_show(match_in_combo);
   gtk_box_pack_start(GTK_BOX(match_box3), match_in_combo, TRUE, TRUE, 5);
 
   filters_frame = gtk_frame_new(_("Filters"));
   gtk_widget_show(filters_frame);
   gtk_box_pack_start(GTK_BOX(box3), filters_frame, TRUE, TRUE, 0);
 
   filters_clist = gtk_clist_new_with_titles(1, filters_clist_titles);
   gtk_widget_set_name(filters_clist, "filters_clist");
   gtk_object_set_data(GTK_OBJECT(frmFilters), "filters_clist", filters_clist);
   gtk_signal_connect(GTK_OBJECT(filters_clist), "select_row", GTK_SIGNAL_FUNC(on_clistrow_selected), NULL);
   gtk_clist_column_titles_passive(GTK_CLIST(filters_clist));
   gtk_container_add(GTK_CONTAINER(filters_frame), filters_clist);
   gtk_widget_show(filters_clist);
 
   buttons_box1 = gtk_hbox_new(FALSE, FALSE);
   gtk_widget_show(buttons_box1);
   gtk_box_pack_start(GTK_BOX(box4), buttons_box1, FALSE, FALSE, 5);
   
   cmdFiltersSave = gtk_button_new_with_label(_("Save"));
   gtk_signal_connect(GTK_OBJECT(cmdFiltersSave), "clicked", GTK_SIGNAL_FUNC(on_cmdFiltersSave_clicked), NULL);
   gtk_widget_show(cmdFiltersSave);
   gtk_box_pack_end(GTK_BOX(buttons_box1), cmdFiltersSave, FALSE, FALSE, 5);
 
   cmdFiltersNew = gtk_button_new_with_label(_("New"));
   gtk_widget_show(cmdFiltersNew);
   gtk_signal_connect(GTK_OBJECT(cmdFiltersNew), "clicked", GTK_SIGNAL_FUNC(on_cmdFiltersNew_clicked), NULL);
   gtk_box_pack_end(GTK_BOX(buttons_box1), cmdFiltersNew, FALSE, FALSE, 5);
   
   cmdFiltersDel = gtk_button_new_with_label(_("Del"));
   gtk_widget_show(cmdFiltersDel);
   gtk_signal_connect(GTK_OBJECT(cmdFiltersDel), "clicked", GTK_SIGNAL_FUNC(on_cmdFiltersDel_clicked), NULL);
   gtk_box_pack_end(GTK_BOX(buttons_box1), cmdFiltersDel, FALSE, FALSE, 5);
   
   cmdFiltersOk = gtk_button_new_with_label(_("OK"));
   gtk_widget_show(cmdFiltersOk);
   gtk_signal_connect(GTK_OBJECT(cmdFiltersOk), "clicked", GTK_SIGNAL_FUNC(on_cmdFiltersOk_clicked), NULL);
   gtk_box_pack_end(GTK_BOX(buttons_box1), cmdFiltersOk, FALSE, FALSE, 5);
 
   
   return frmFilters;
}
 
GtkWidget *create_dlgNewFilter(void)
{
 	GtkWidget *dlgNewFilter;
 	GtkWidget *box1;
 	GtkWidget *newfilter_entry;
 	GtkWidget *label;
 	GtkWidget *button;
 
 	dlgNewFilter = gtk_window_new(GTK_WINDOW_TOPLEVEL);
 	gtk_window_set_title(GTK_WINDOW(dlgNewFilter), _("Name of the Filter?"));
 	gtk_widget_set_usize(dlgNewFilter, 300, 170);
 	gtk_container_set_border_width(GTK_CONTAINER(dlgNewFilter), 10);
 
 	box1 = gtk_vbox_new(FALSE, FALSE);
 	gtk_widget_show(box1);
 	gtk_container_add(GTK_CONTAINER(dlgNewFilter), box1);
 
 	label = gtk_label_new(_("Name of the Filter?"));
 	gtk_widget_show(label);
 	gtk_box_pack_start(GTK_BOX(box1), label, FALSE, FALSE, 0);
 	
 	newfilter_entry = gtk_entry_new();
 	gtk_widget_set_name(newfilter_entry, "newfilter_entry");
 	gtk_object_set_data(GTK_OBJECT(dlgNewFilter), "newfilter_entry", newfilter_entry);
 	gtk_box_pack_start(GTK_BOX(box1), newfilter_entry, FALSE, FALSE, 0);
 	gtk_widget_show(newfilter_entry);
 
 	button = gtk_button_new_with_label(_("Ok"));
 	gtk_widget_show(button);
 	gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(on_dlgNewFilterOk_clicked), NULL);
 	gtk_box_pack_end(GTK_BOX(box1), button, FALSE, FALSE, 0);
 
 	return dlgNewFilter;
 
}

void on_frmFilters_destroy (GtkObject *object, gpointer user_data)
{
   gtk_widget_destroy(frmFilters);
   FiltersOpen = 0;
}

void on_dlgNewFilter_destroy (GtkObject *object, gpointer user_data)
{
   gtk_widget_destroy(dlgNewFilter);
}

void on_cmdFiltersOk_clicked (GtkWidget *ob, gpointer user_data)
{
 	filters_save();
 	gtk_widget_destroy(frmFilters);
 	FiltersOpen = 0;
}
 
void on_cmdFiltersDel_clicked (GtkWidget *ob, gpointer user_data)
{
 	GtkWidget *clist;
 	GtkWidget *match_entry;
 	GtkWidget *in_combo;
 	GtkWidget *move_combo;
 	GtkWidget *forward_entry;
 	GtkWidget *move_button;
 	GList *selection;
 	GList *tmp;
 	gint i = 0;
 
 	clist = get_widget(frmFilters, "filters_clist");
 	match_entry = get_widget(frmFilters, "match_text_entry");
 	in_combo = get_widget(frmFilters, "match_in_combo");
 	move_combo = get_widget(frmFilters, "action_move_combo");
 	move_button = get_widget(frmFilters, "action_move_button");
 	forward_entry = get_widget(frmFilters, "action_forward_entry");
 
 	tmp = filters;
 	selection = GTK_CLIST(clist)->selection;
 	while(selection != NULL)
   {
 		while(i < (int)selection->data)
      {
 			i++;
 			tmp = tmp->next;
 		}
 		free(tmp->data);
 		g_list_remove(filters, tmp->data);
 		selection = selection->next;
 
   }
 	
 	gtk_entry_set_text(GTK_ENTRY(match_entry), "");
 	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(in_combo)->entry), "");
 	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(move_combo)->entry), "");
 	gtk_entry_set_text(GTK_ENTRY(forward_entry), "");
 	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(move_button), 1);
 	
 	filters_refresh();
 	rc_save_defaults();
}
 
void on_cmdFiltersNew_clicked (GtkWidget *ob, gpointer user_data)
{
 	dlgNewFilter = create_dlgNewFilter();
 	gtk_widget_show(dlgNewFilter);
}
 
void on_cmdFiltersSave_clicked (GtkWidget *ob, gpointer user_data)
{
 	filters_save();
}
 
void on_cmdFiltersMoveComboButton_clicked (GtkWidget *ob, gpointer user_data)
{
 	int i = 0;
 	gchar *box;
 	GtkWidget *combo = get_widget(frmFilters, "action_move_combo");
 	GtkWidget *clist = get_widget(frmMain, "clistBoxes");
 	
 	if(filters_mailboxes != NULL)
   {
 		g_list_free(filters_mailboxes);
 		filters_mailboxes = NULL;
 	}

 	while(i < NumMailboxes)
   {
 		gtk_clist_get_text(GTK_CLIST(clist), i, 0, &box);
 		filters_mailboxes = g_list_append(filters_mailboxes, box);
 		i++;
 	}
 
 	if(i)
   {
 		gtk_combo_set_popdown_strings(GTK_COMBO(combo), filters_mailboxes);
 	}
 	else
   {
 		/* if they have just deleted all their mailboxes we want this dropdown
 		   to reflect it */
 		gtk_combo_set_popdown_strings(GTK_COMBO(combo), NULL);
 	}
 }
 
void on_clistrow_selected (GtkWidget *ob, gint row, gint column, GdkEventButton *event, gpointer user_data)
{
 	gint i = 0;
 	struct filter *flt;
 	GtkWidget *match_in       = get_widget(frmFilters, "match_in_combo");
 	GtkWidget *match_text     = get_widget(frmFilters, "match_text_entry");
 	GtkWidget *move_combo     = get_widget(frmFilters, "action_move_combo");
 	GtkWidget *move_button    = get_widget(frmFilters, "action_move_button");
 	GtkWidget *forward_entry  = get_widget(frmFilters, "action_forward_entry");
 	GtkWidget *forward_button = get_widget(frmFilters, "action_forward_button");
 	GtkWidget *delete_button  = get_widget(frmFilters, "action_delete_button");
 	GList *tmp;
 	
 	tmp = filters;
 	while(i < row)
   {
 		tmp = tmp->next;
 		i++;
 	}
 	flt = tmp->data;
 	gtk_entry_set_text(GTK_ENTRY(match_text), flt->match);
 	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(match_in)->entry), flt->in);
 	if(flt->action == 1)
   {
 		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(move_button), 1);
 		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(move_combo)->entry), flt->to);
 		gtk_entry_set_text(GTK_ENTRY(forward_entry), "");
 	}
 	if(flt->action == 2)
   {
 		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(forward_button), 1);
 		gtk_entry_set_text(GTK_ENTRY(forward_entry), flt->to);
 		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(move_combo)->entry), "");
 	}
 	if(flt->action == 3)
   {
 		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(delete_button), 1);
 		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(move_combo)->entry), "");
 		gtk_entry_set_text(GTK_ENTRY(forward_entry), "");
 	}
}
 
void on_dlgNewFilterOk_clicked (GtkWidget *ob, gpointer user_data)
{
 	struct filter *flt;
 	GtkWidget *entry = get_widget(dlgNewFilter, "newfilter_entry");
 	GtkWidget *clist = get_widget(frmFilters, "filters_clist");
 	char *name;
 
 	name = gtk_entry_get_text(GTK_ENTRY(entry));
 	
 	if(name[0] != '\0')
   {
		flt = g_malloc(sizeof(struct filter));
 		memset(flt, 0, sizeof(struct filter));
 	
 		strncpy(flt->name, name, 64);
 		filters = g_list_append(filters, flt);
 		filters_refresh();
 		gtk_clist_select_row(GTK_CLIST(clist), GTK_CLIST(clist)->rows - 1, 0);
 	}

 	gtk_widget_destroy(dlgNewFilter);
 
}
 
void filters_save(void)
{
 	GtkWidget *move_button    = get_widget(frmFilters, "action_move_button");
 	GtkWidget *move_combo     = get_widget(frmFilters, "action_move_combo");
 	GtkWidget *forward_button = get_widget(frmFilters, "action_forward_button");
 	GtkWidget *forward_entry  = get_widget(frmFilters, "action_forward_entry");
 	GtkWidget *delete_button  = get_widget(frmFilters, "action_delete_button");
 	GtkWidget *match_text     = get_widget(frmFilters, "match_text_entry");
 	GtkWidget *match_in       = get_widget(frmFilters, "match_in_combo");
 	GtkWidget *clist          = get_widget(frmFilters, "filters_clist");
 	GList *selection;
 	GList *tmp;
 	struct filter *flt;
 	gint i = 0;

 	selection = GTK_CLIST(clist)->selection;
 	if(selection == NULL)
 		return;
 	tmp = filters;
 	if(tmp == NULL)
 		return;
 	
 	while(i < (int)selection->data)
   {
 		tmp = tmp->next;
 		i++;
 	}
 	flt = tmp->data;
 	strncpy(flt->match, gtk_entry_get_text(GTK_ENTRY(match_text)), 127);
 	strncpy(flt->in, gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(match_in)->entry)), 127);
 	if(GTK_TOGGLE_BUTTON(move_button)->active)
   {
 		flt->action = 1;
 		strncpy(flt->to, gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(move_combo)->entry)), 127);
 	}
 	if(GTK_TOGGLE_BUTTON(forward_button)->active)
   {
 		flt->action = 2;
 		strncpy(flt->to, gtk_entry_get_text(GTK_ENTRY(forward_entry)), 127);
 	}
 	if(GTK_TOGGLE_BUTTON(delete_button)->active)
   {
 		flt->action = 3;
 	}
 	rc_save_defaults();
}
 
int filters_read(void)
{
   gchar buffer[257];
   FILE *fp;
   gchar *name  = NULL;
   gchar *to    = NULL;
   gchar *match = NULL;
   gchar *in;
   gint action;
   struct filter *flt;
  
   fp = fopen(spruceconf, "rt");
   if (fp == NULL)
   {
      fprintf(stderr, "Spruce: %s failed to open for reading.\n", spruceconf);
      fprintf(stderr, "Please check with your local Administrator.\n");
      return 0;
   }

   while (!feof(fp))
   {
      fgets(buffer, 256, fp);
      trim_leadspc(buffer);
      if(buffer[0] != '\n' && buffer[0] != '#')
      {
         if (!strncmp("filter", buffer, strlen("filter")))
         {
            strcut(buffer, 0, strlen("filter"));
            trim_whtspc(buffer);

            name   = get_field(buffer, 1, '^');
            match  = get_field(buffer, 2, '^');
            in     = get_field(buffer, 3, '^');
            action = atoi(get_field(buffer, 4, '^'));
            to     = get_field(buffer, 5, '^');
         			
            flt = g_malloc(sizeof(struct filter));
 	         memset(flt, 0, sizeof(struct filter));

            strncpy(flt->name, name, 63);
            strncpy(flt->match, match, 127);
            strncpy(flt->in, in, 127);
            flt->action = action;
            strncpy(flt->to, to, 127);

            filters = g_list_append(filters, flt);
         }
      }
   }
 
   fclose(fp);
   return 1;
}
 
void filters_refresh(void)
{
   GtkWidget *clist;
   GList *tmp;
   struct filter *flt;
   int i = 1;
   gchar *text[1];
 
   clist = get_widget(frmFilters, "filters_clist");
   gtk_clist_clear(GTK_CLIST(clist));

   tmp = filters;
   while(tmp != NULL)
   {
      flt = tmp->data;
      text[0] = flt->name;
      gtk_clist_append(GTK_CLIST(clist), text);
      tmp = tmp->next;
      i++;
   }
}
 
/* returns 1 if a filter was found for the mail , otherwise 0. */
int check_filters(FILE *file)
{
   FILE *folder;
   gint matched = 0;
   gchar buffer[256];
   gchar inmatch[256];
   struct filter *flt = NULL;
   GList *tmp;

   fseek(file, 0, SEEK_SET);
   memset(buffer, 0, sizeof(buffer));

   tmp = filters;
   while(tmp != NULL)
   {
      flt = tmp->data;
      while((fgets(buffer, 255, file)))
      {
         if(!strncasecmp("Any recipient", flt->in, 13))
         {
            if(!strncasecmp("To:", buffer, 3))
               strcpy(inmatch, "To:");
            if(!strncasecmp("Cc:", buffer, 3))
               strcpy(inmatch, "Cc:");
         }
         else
            strcpy(inmatch, flt->in);
         if(!strncasecmp(inmatch, buffer, strlen(inmatch)))
         {
            strcut(buffer, 0, strlen(inmatch));
            trim_whtspc(buffer);
            if(strstrcase(buffer, flt->match) != NULL)
            {
               matched = flt->action;
               goto out;
            }
         }
      }
      fseek(file, 0, SEEK_SET);
      tmp = tmp->next;
   }

   out:
   if(matched)
   {
      switch(matched)
      {
            case 1: /* move to folder */
            fseek(file, 0, SEEK_SET);
            folder = fopen(get_mailbox(flt->to), "at+");
            while(fgets(buffer, 255, file))
            {
               fprintf(folder, "%s", buffer);
            }
            fclose(folder);
            break;
         case 2: /* forward - not done yet */
            break;
         case 3: /* delete it - dont have to do anything */
            break;
      }
      return 1;
   }

   return 0;
}
