/*  Spruce
 *  Copyright (C) 1999 Susixware
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __MAIN_H__
#define __MAIN_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gtk/gtk.h>
#undef MIN
#undef MAX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
/*#include <pthread.h>*/

#include "gtkmanip.h"
#include "globals.h"
#include "mailbox.h"
#include "pop3io.h"
#include "rc.h"
#include "sort.h"
#include "pgp.h"

#include "about.h"
#include "accounts.h"
#include "addrbook.h"
#include "composer.h"
#include "filters.h"
#include "options.h"
#include "print.h"
#include "mesgreader.h"
#include "mime.h"

/* icons */
#include "xpm/check.xpm"
#include "xpm/new.xpm"
#include "xpm/msave.xpm"
#include "xpm/print.xpm"
#include "xpm/reply.xpm"
#include "xpm/fwd.xpm"
#include "xpm/maddr.xpm"
#include "xpm/del.xpm"
#include "xpm/larrow.xpm"
#include "xpm/rarrow.xpm"

#define TOP 0
#define STAY 1
#define BOTTOM -1

#define SHOW_STATUS_DIALOG 1
#define HIDE_STATUS_DIALOG 2

#define MCOPY 1
#define MMOVE 2

const struct option CMDLINE[] =
{
  {"help",     no_argument, 0, 'h'},
  {"version",  no_argument, 0, 'v'},
  {"bindings", no_argument, 0,  1 },
  {"icons",    no_argument, 0, 'i'},
  {"text",     no_argument, 0, 't'},
  {"both",     no_argument, 0, 'b'},
  {NULL,       0,           0,   0}
};

GtkWidget* create_frmMain (void);
GtkWidget* create_frmMainSaveAs (void);
GtkWidget* create_dlgNewMailbox (void);
GtkWidget* create_dlgCopyMove (gchar *title);

void on_frmMain_destroy (GtkObject *object, gpointer user_data);

void on_mnuNew_Message_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdNew_clicked (GtkWidget *widget, gpointer data);

void on_mnuSave_As_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdSave_clicked (GtkWidget *widget, gpointer data);

void on_mnuPrint_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdPrintToolbar_clicked (GtkWidget *widget, gpointer data);

void mail_check (gboolean show_dialog);

void on_mnuCheck_Mail_activate (GtkMenuItem *menuitem, gpointer user_data);

gint periodic_mail_check (gpointer data);

void on_cmdCheckMail_clicked (GtkWidget *widget, gpointer data);

void on_mnuExit_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuAddress_Book_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdAddrbk_clicked (GtkWidget *widget, gpointer data);

void on_mnuAccounts_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuFilters_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuOptions_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMailboxCreate_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMailboxDelete_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMesgNext_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdNext_clicked (GtkWidget *widget, gpointer data);

void on_mnuMesgPrevious_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdPrevious_clicked (GtkWidget *widget, gpointer data);

void on_mnuMesgReply_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdReply_clicked (GtkWidget *widget, gpointer data);

void on_mnuMesgForward_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdFwd_clicked (GtkWidget *widget, gpointer data);

void on_mnuMesgOpen_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMesgDelete_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_cmdDel_clicked (GtkWidget *widget, gpointer data);

void on_mnuMesgExpunge_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuCopy_to_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMove_to_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMimeSave_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuMimeSave_file (GtkWidget *button, GtkFileSelection *file_sel);

void on_mnuMimeSave_file_cancel (GtkWidget *button, GtkFileSelection *file_sel);

void on_mnuAbout_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_mnuHowto_activate (GtkMenuItem *menuitem, gpointer user_data);

void on_clistMail_select_row (GtkCList *clist, gint row, gint column,
				     GdkEvent *event, gpointer user_data);

void on_clistMail_clicked (GtkWidget *clist, GdkEvent *event, 
			   gpointer user_data);

void on_clistMail_drag_data_get (GtkWidget *clist, GdkDragContext *context, GtkSelectionData *selection,guint info,guint32 clk_time, gpointer user_data);

void on_clistMail_click_column (GtkWidget *clist, gint column, gpointer user_data);

void on_clistBoxes_select_row (GtkCList *clist, gint row, gint column,
                               GdkEvent *event, gpointer user_data);

void on_clistBoxes_clicked (GtkWidget *clist, GdkEvent *event, 
				   gpointer user_data);

void on_clistBoxes_drag_data_recieved (GtkWidget *clist,GdkDragContext *context,gint x,gint y,GtkSelectionData *selection_data,guint info,guint32 clk_time);

void on_clistMime_select_row (GtkWidget *clist, gint row, gint col, 
				     gpointer user_data);

void on_frmMainSaveAs_destroy (GtkObject *object, gpointer user_data);

void on_cmdMainSaveAs_OK_clicked (GtkButton *button, gpointer user_data);

void on_cmdMainSaveAs_Cancel_clicked (GtkButton *button, 
					     gpointer user_data);

void on_dlgNewMailbox_destroy (GtkObject *object, gpointer user_data);

void on_cmdDlgNewMailboxOK_clicked (GtkButton *button, gpointer user_data);

void on_cmdDlgNewMailboxCancel_clicked (GtkButton *button, 
					       gpointer user_data);

void on_dlgCopyMove_destroy (GtkObject *object, gpointer user_data);

void on_cmdCopyMoveOK_clicked (GtkButton *button, gpointer user_data);

void on_cmdCopyMoveCancel_clicked (GtkButton *button, 
					  gpointer user_data);

gint save_message(void);

void refresh_mailboxes(gint hilite);

void refresh_mail_list(gint hilite);

void refresh_txtMessage(void);

void refresh_clistMime(void);

gchar *quote_body (gchar *body, gchar *rcpt, gchar *date);

void spruce_init(gint argc, gchar **argv);

void spruce_help(gchar *program);

void clistMail_update(void);

void read_sizes (void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
